unit schAlbaranesProveedorClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDAInterfaces, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_AlbaranesProveedor = '{FC51EA41-4822-47DC-9EA6-8A81B75EEBF0}';
  RID_AlbaranesProveedor_Detalles = '{D33B5B6F-E114-4A97-B524-94872D62277C}';

  { Data table names }
  nme_AlbaranesProveedor = 'AlbaranesProveedor';
  nme_AlbaranesProveedor_Detalles = 'AlbaranesProveedor_Detalles';

  { AlbaranesProveedor fields }
  fld_AlbaranesProveedorID = 'ID';
  fld_AlbaranesProveedorID_EMPRESA = 'ID_EMPRESA';
  fld_AlbaranesProveedorID_PROVEEDOR = 'ID_PROVEEDOR';
  fld_AlbaranesProveedorNOMBRE = 'NOMBRE';
  fld_AlbaranesProveedorFECHA_ALBARAN = 'FECHA_ALBARAN';
  fld_AlbaranesProveedorREFERENCIA = 'REFERENCIA';
  fld_AlbaranesProveedorREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';
  fld_AlbaranesProveedorTIPO = 'TIPO';
  fld_AlbaranesProveedorID_ALMACEN = 'ID_ALMACEN';
  fld_AlbaranesProveedorNOMBRE_ALMACEN = 'NOMBRE_ALMACEN';
  fld_AlbaranesProveedorID_PEDIDO = 'ID_PEDIDO';
  fld_AlbaranesProveedorREF_PED_PROVEEDOR = 'REF_PED_PROVEEDOR';
  fld_AlbaranesProveedorID_FACTURA = 'ID_FACTURA';
  fld_AlbaranesProveedorREF_FACTURA = 'REF_FACTURA';
  fld_AlbaranesProveedorREF_FACTURA_PROV = 'REF_FACTURA_PROV';
  fld_AlbaranesProveedorCALLE = 'CALLE';
  fld_AlbaranesProveedorCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_AlbaranesProveedorPOBLACION = 'POBLACION';
  fld_AlbaranesProveedorPROVINCIA = 'PROVINCIA';
  fld_AlbaranesProveedorPERSONA_CONTACTO = 'PERSONA_CONTACTO';
  fld_AlbaranesProveedorTELEFONO = 'TELEFONO';
  fld_AlbaranesProveedorIMPORTE_NETO = 'IMPORTE_NETO';
  fld_AlbaranesProveedorIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_AlbaranesProveedorDESCUENTO = 'DESCUENTO';
  fld_AlbaranesProveedorIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_AlbaranesProveedorBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_AlbaranesProveedorID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_AlbaranesProveedorIVA = 'IVA';
  fld_AlbaranesProveedorIMPORTE_IVA = 'IMPORTE_IVA';
  fld_AlbaranesProveedorIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_AlbaranesProveedorOBSERVACIONES = 'OBSERVACIONES';
  fld_AlbaranesProveedorINCIDENCIAS = 'INCIDENCIAS';
  fld_AlbaranesProveedorINCIDENCIAS_ACTIVAS = 'INCIDENCIAS_ACTIVAS';
  fld_AlbaranesProveedorFECHA_ALTA = 'FECHA_ALTA';
  fld_AlbaranesProveedorFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_AlbaranesProveedorUSUARIO = 'USUARIO';
  fld_AlbaranesProveedorID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_AlbaranesProveedorID_TIENDA = 'ID_TIENDA';
  fld_AlbaranesProveedorTIENDA = 'TIENDA';

  { AlbaranesProveedor field indexes }
  idx_AlbaranesProveedorID = 0;
  idx_AlbaranesProveedorID_EMPRESA = 1;
  idx_AlbaranesProveedorID_PROVEEDOR = 2;
  idx_AlbaranesProveedorNOMBRE = 3;
  idx_AlbaranesProveedorFECHA_ALBARAN = 4;
  idx_AlbaranesProveedorREFERENCIA = 5;
  idx_AlbaranesProveedorREFERENCIA_PROVEEDOR = 6;
  idx_AlbaranesProveedorTIPO = 7;
  idx_AlbaranesProveedorID_ALMACEN = 8;
  idx_AlbaranesProveedorNOMBRE_ALMACEN = 9;
  idx_AlbaranesProveedorID_PEDIDO = 10;
  idx_AlbaranesProveedorREF_PED_PROVEEDOR = 11;
  idx_AlbaranesProveedorID_FACTURA = 12;
  idx_AlbaranesProveedorREF_FACTURA = 13;
  idx_AlbaranesProveedorREF_FACTURA_PROV = 14;
  idx_AlbaranesProveedorCALLE = 15;
  idx_AlbaranesProveedorCODIGO_POSTAL = 16;
  idx_AlbaranesProveedorPOBLACION = 17;
  idx_AlbaranesProveedorPROVINCIA = 18;
  idx_AlbaranesProveedorPERSONA_CONTACTO = 19;
  idx_AlbaranesProveedorTELEFONO = 20;
  idx_AlbaranesProveedorIMPORTE_NETO = 21;
  idx_AlbaranesProveedorIMPORTE_PORTE = 22;
  idx_AlbaranesProveedorDESCUENTO = 23;
  idx_AlbaranesProveedorIMPORTE_DESCUENTO = 24;
  idx_AlbaranesProveedorBASE_IMPONIBLE = 25;
  idx_AlbaranesProveedorID_TIPO_IVA = 26;
  idx_AlbaranesProveedorIVA = 27;
  idx_AlbaranesProveedorIMPORTE_IVA = 28;
  idx_AlbaranesProveedorIMPORTE_TOTAL = 29;
  idx_AlbaranesProveedorOBSERVACIONES = 30;
  idx_AlbaranesProveedorINCIDENCIAS = 31;
  idx_AlbaranesProveedorINCIDENCIAS_ACTIVAS = 32;
  idx_AlbaranesProveedorFECHA_ALTA = 33;
  idx_AlbaranesProveedorFECHA_MODIFICACION = 34;
  idx_AlbaranesProveedorUSUARIO = 35;
  idx_AlbaranesProveedorID_FORMA_PAGO = 36;
  idx_AlbaranesProveedorID_TIENDA = 37;
  idx_AlbaranesProveedorTIENDA = 38;

  { AlbaranesProveedor_Detalles fields }
  fld_AlbaranesProveedor_DetallesID = 'ID';
  fld_AlbaranesProveedor_DetallesID_ALBARAN = 'ID_ALBARAN';
  fld_AlbaranesProveedor_DetallesPOSICION = 'POSICION';
  fld_AlbaranesProveedor_DetallesTIPO_DETALLE = 'TIPO_DETALLE';
  fld_AlbaranesProveedor_DetallesCONCEPTO = 'CONCEPTO';
  fld_AlbaranesProveedor_DetallesCANTIDAD = 'CANTIDAD';
  fld_AlbaranesProveedor_DetallesIMPORTE_UNIDAD = 'IMPORTE_UNIDAD';
  fld_AlbaranesProveedor_DetallesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_AlbaranesProveedor_DetallesVISIBLE = 'VISIBLE';
  fld_AlbaranesProveedor_DetallesID_ARTICULO = 'ID_ARTICULO';
  fld_AlbaranesProveedor_DetallesDESCUENTO = 'DESCUENTO';
  fld_AlbaranesProveedor_DetallesIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_AlbaranesProveedor_DetallesREFERENCIA = 'REFERENCIA';
  fld_AlbaranesProveedor_DetallesREFERENCIA_PROVEEDOR = 'REFERENCIA_PROVEEDOR';

  { AlbaranesProveedor_Detalles field indexes }
  idx_AlbaranesProveedor_DetallesID = 0;
  idx_AlbaranesProveedor_DetallesID_ALBARAN = 1;
  idx_AlbaranesProveedor_DetallesPOSICION = 2;
  idx_AlbaranesProveedor_DetallesTIPO_DETALLE = 3;
  idx_AlbaranesProveedor_DetallesCONCEPTO = 4;
  idx_AlbaranesProveedor_DetallesCANTIDAD = 5;
  idx_AlbaranesProveedor_DetallesIMPORTE_UNIDAD = 6;
  idx_AlbaranesProveedor_DetallesIMPORTE_TOTAL = 7;
  idx_AlbaranesProveedor_DetallesVISIBLE = 8;
  idx_AlbaranesProveedor_DetallesID_ARTICULO = 9;
  idx_AlbaranesProveedor_DetallesDESCUENTO = 10;
  idx_AlbaranesProveedor_DetallesIMPORTE_PORTE = 11;
  idx_AlbaranesProveedor_DetallesREFERENCIA = 12;
  idx_AlbaranesProveedor_DetallesREFERENCIA_PROVEEDOR = 13;

type
  { IAlbaranesProveedor }
  IAlbaranesProveedor = interface(IDAStronglyTypedDataTable)
  ['{5166113D-4E31-4A0E-9B2A-D95DE1724A0C}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetID_PROVEEDORValue: Integer;
    procedure SetID_PROVEEDORValue(const aValue: Integer);
    function GetID_PROVEEDORIsNull: Boolean;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetFECHA_ALBARANValue: DateTime;
    procedure SetFECHA_ALBARANValue(const aValue: DateTime);
    function GetFECHA_ALBARANIsNull: Boolean;
    procedure SetFECHA_ALBARANIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetTIPOIsNull: Boolean;
    procedure SetTIPOIsNull(const aValue: Boolean);
    function GetID_ALMACENValue: Integer;
    procedure SetID_ALMACENValue(const aValue: Integer);
    function GetID_ALMACENIsNull: Boolean;
    procedure SetID_ALMACENIsNull(const aValue: Boolean);
    function GetNOMBRE_ALMACENValue: String;
    procedure SetNOMBRE_ALMACENValue(const aValue: String);
    function GetNOMBRE_ALMACENIsNull: Boolean;
    procedure SetNOMBRE_ALMACENIsNull(const aValue: Boolean);
    function GetID_PEDIDOValue: Integer;
    procedure SetID_PEDIDOValue(const aValue: Integer);
    function GetID_PEDIDOIsNull: Boolean;
    procedure SetID_PEDIDOIsNull(const aValue: Boolean);
    function GetREF_PED_PROVEEDORValue: String;
    procedure SetREF_PED_PROVEEDORValue(const aValue: String);
    function GetREF_PED_PROVEEDORIsNull: Boolean;
    procedure SetREF_PED_PROVEEDORIsNull(const aValue: Boolean);
    function GetID_FACTURAValue: Integer;
    procedure SetID_FACTURAValue(const aValue: Integer);
    function GetID_FACTURAIsNull: Boolean;
    procedure SetID_FACTURAIsNull(const aValue: Boolean);
    function GetREF_FACTURAValue: String;
    procedure SetREF_FACTURAValue(const aValue: String);
    function GetREF_FACTURAIsNull: Boolean;
    procedure SetREF_FACTURAIsNull(const aValue: Boolean);
    function GetREF_FACTURA_PROVValue: String;
    procedure SetREF_FACTURA_PROVValue(const aValue: String);
    function GetREF_FACTURA_PROVIsNull: Boolean;
    procedure SetREF_FACTURA_PROVIsNull(const aValue: Boolean);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetCALLEIsNull: Boolean;
    procedure SetCALLEIsNull(const aValue: Boolean);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetCODIGO_POSTALIsNull: Boolean;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPOBLACIONIsNull: Boolean;
    procedure SetPOBLACIONIsNull(const aValue: Boolean);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPROVINCIAIsNull: Boolean;
    procedure SetPROVINCIAIsNull(const aValue: Boolean);
    function GetPERSONA_CONTACTOValue: String;
    procedure SetPERSONA_CONTACTOValue(const aValue: String);
    function GetPERSONA_CONTACTOIsNull: Boolean;
    procedure SetPERSONA_CONTACTOIsNull(const aValue: Boolean);
    function GetTELEFONOValue: String;
    procedure SetTELEFONOValue(const aValue: String);
    function GetTELEFONOIsNull: Boolean;
    procedure SetTELEFONOIsNull(const aValue: Boolean);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_NETOIsNull: Boolean;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIMPORTE_DESCUENTOIsNull: Boolean;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetBASE_IMPONIBLEIsNull: Boolean;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetID_TIPO_IVAIsNull: Boolean;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIVAIsNull: Boolean;
    procedure SetIVAIsNull(const aValue: Boolean);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetIMPORTE_IVAIsNull: Boolean;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetOBSERVACIONESValue: IROStrings;
    function GetOBSERVACIONESIsNull: Boolean;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean);
    function GetINCIDENCIASValue: IROStrings;
    function GetINCIDENCIASIsNull: Boolean;
    procedure SetINCIDENCIASIsNull(const aValue: Boolean);
    function GetINCIDENCIAS_ACTIVASValue: Integer;
    procedure SetINCIDENCIAS_ACTIVASValue(const aValue: Integer);
    function GetINCIDENCIAS_ACTIVASIsNull: Boolean;
    procedure SetINCIDENCIAS_ACTIVASIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetID_FORMA_PAGOIsNull: Boolean;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean);
    function GetID_TIENDAValue: Integer;
    procedure SetID_TIENDAValue(const aValue: Integer);
    function GetID_TIENDAIsNull: Boolean;
    procedure SetID_TIENDAIsNull(const aValue: Boolean);
    function GetTIENDAValue: String;
    procedure SetTIENDAValue(const aValue: String);
    function GetTIENDAIsNull: Boolean;
    procedure SetTIENDAIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property FECHA_ALBARAN: DateTime read GetFECHA_ALBARANValue write SetFECHA_ALBARANValue;
    property FECHA_ALBARANIsNull: Boolean read GetFECHA_ALBARANIsNull write SetFECHA_ALBARANIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull: Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property NOMBRE_ALMACEN: String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property NOMBRE_ALMACENIsNull: Boolean read GetNOMBRE_ALMACENIsNull write SetNOMBRE_ALMACENIsNull;
    property ID_PEDIDO: Integer read GetID_PEDIDOValue write SetID_PEDIDOValue;
    property ID_PEDIDOIsNull: Boolean read GetID_PEDIDOIsNull write SetID_PEDIDOIsNull;
    property REF_PED_PROVEEDOR: String read GetREF_PED_PROVEEDORValue write SetREF_PED_PROVEEDORValue;
    property REF_PED_PROVEEDORIsNull: Boolean read GetREF_PED_PROVEEDORIsNull write SetREF_PED_PROVEEDORIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property REF_FACTURA: String read GetREF_FACTURAValue write SetREF_FACTURAValue;
    property REF_FACTURAIsNull: Boolean read GetREF_FACTURAIsNull write SetREF_FACTURAIsNull;
    property REF_FACTURA_PROV: String read GetREF_FACTURA_PROVValue write SetREF_FACTURA_PROVValue;
    property REF_FACTURA_PROVIsNull: Boolean read GetREF_FACTURA_PROVIsNull write SetREF_FACTURA_PROVIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property PERSONA_CONTACTOIsNull: Boolean read GetPERSONA_CONTACTOIsNull write SetPERSONA_CONTACTOIsNull;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property TELEFONOIsNull: Boolean read GetTELEFONOIsNull write SetTELEFONOIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property INCIDENCIAS: IROStrings read GetINCIDENCIASValue;
    property INCIDENCIASIsNull: Boolean read GetINCIDENCIASIsNull write SetINCIDENCIASIsNull;
    property INCIDENCIAS_ACTIVAS: Integer read GetINCIDENCIAS_ACTIVASValue write SetINCIDENCIAS_ACTIVASValue;
    property INCIDENCIAS_ACTIVASIsNull: Boolean read GetINCIDENCIAS_ACTIVASIsNull write SetINCIDENCIAS_ACTIVASIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property ID_TIENDA: Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull: Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property TIENDA: String read GetTIENDAValue write SetTIENDAValue;
    property TIENDAIsNull: Boolean read GetTIENDAIsNull write SetTIENDAIsNull;
  end;

  { TAlbaranesProveedorDataTableRules }
  TAlbaranesProveedorDataTableRules = class(TIntfObjectDADataTableRules, IAlbaranesProveedor)
  private
    f_OBSERVACIONES: IROStrings;
    f_INCIDENCIAS: IROStrings;
    procedure OBSERVACIONES_OnChange(Sender: TObject);
    procedure INCIDENCIAS_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetID_PROVEEDORValue: Integer; virtual;
    procedure SetID_PROVEEDORValue(const aValue: Integer); virtual;
    function GetID_PROVEEDORIsNull: Boolean; virtual;
    procedure SetID_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALBARANValue: DateTime; virtual;
    procedure SetFECHA_ALBARANValue(const aValue: DateTime); virtual;
    function GetFECHA_ALBARANIsNull: Boolean; virtual;
    procedure SetFECHA_ALBARANIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetTIPOIsNull: Boolean; virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;
    function GetID_ALMACENValue: Integer; virtual;
    procedure SetID_ALMACENValue(const aValue: Integer); virtual;
    function GetID_ALMACENIsNull: Boolean; virtual;
    procedure SetID_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_ALMACENValue: String; virtual;
    procedure SetNOMBRE_ALMACENValue(const aValue: String); virtual;
    function GetNOMBRE_ALMACENIsNull: Boolean; virtual;
    procedure SetNOMBRE_ALMACENIsNull(const aValue: Boolean); virtual;
    function GetID_PEDIDOValue: Integer; virtual;
    procedure SetID_PEDIDOValue(const aValue: Integer); virtual;
    function GetID_PEDIDOIsNull: Boolean; virtual;
    procedure SetID_PEDIDOIsNull(const aValue: Boolean); virtual;
    function GetREF_PED_PROVEEDORValue: String; virtual;
    procedure SetREF_PED_PROVEEDORValue(const aValue: String); virtual;
    function GetREF_PED_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREF_PED_PROVEEDORIsNull(const aValue: Boolean); virtual;
    function GetID_FACTURAValue: Integer; virtual;
    procedure SetID_FACTURAValue(const aValue: Integer); virtual;
    function GetID_FACTURAIsNull: Boolean; virtual;
    procedure SetID_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetREF_FACTURAValue: String; virtual;
    procedure SetREF_FACTURAValue(const aValue: String); virtual;
    function GetREF_FACTURAIsNull: Boolean; virtual;
    procedure SetREF_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetREF_FACTURA_PROVValue: String; virtual;
    procedure SetREF_FACTURA_PROVValue(const aValue: String); virtual;
    function GetREF_FACTURA_PROVIsNull: Boolean; virtual;
    procedure SetREF_FACTURA_PROVIsNull(const aValue: Boolean); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCALLEIsNull: Boolean; virtual;
    procedure SetCALLEIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetCODIGO_POSTALIsNull: Boolean; virtual;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPOBLACIONIsNull: Boolean; virtual;
    procedure SetPOBLACIONIsNull(const aValue: Boolean); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPROVINCIAIsNull: Boolean; virtual;
    procedure SetPROVINCIAIsNull(const aValue: Boolean); virtual;
    function GetPERSONA_CONTACTOValue: String; virtual;
    procedure SetPERSONA_CONTACTOValue(const aValue: String); virtual;
    function GetPERSONA_CONTACTOIsNull: Boolean; virtual;
    procedure SetPERSONA_CONTACTOIsNull(const aValue: Boolean); virtual;
    function GetTELEFONOValue: String; virtual;
    procedure SetTELEFONOValue(const aValue: String); virtual;
    function GetTELEFONOIsNull: Boolean; virtual;
    procedure SetTELEFONOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_NETOIsNull: Boolean; virtual;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIMPORTE_DESCUENTOIsNull: Boolean; virtual;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetBASE_IMPONIBLEIsNull: Boolean; virtual;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAIsNull: Boolean; virtual;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIVAIsNull: Boolean; virtual;
    procedure SetIVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetIMPORTE_IVAIsNull: Boolean; virtual;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOBSERVACIONESIsNull: Boolean; virtual;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean); virtual;
    function GetINCIDENCIASValue: IROStrings; virtual;
    function GetINCIDENCIASIsNull: Boolean; virtual;
    procedure SetINCIDENCIASIsNull(const aValue: Boolean); virtual;
    function GetINCIDENCIAS_ACTIVASValue: Integer; virtual;
    procedure SetINCIDENCIAS_ACTIVASValue(const aValue: Integer); virtual;
    function GetINCIDENCIAS_ACTIVASIsNull: Boolean; virtual;
    procedure SetINCIDENCIAS_ACTIVASIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetID_FORMA_PAGOIsNull: Boolean; virtual;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean); virtual;
    function GetID_TIENDAValue: Integer; virtual;
    procedure SetID_TIENDAValue(const aValue: Integer); virtual;
    function GetID_TIENDAIsNull: Boolean; virtual;
    procedure SetID_TIENDAIsNull(const aValue: Boolean); virtual;
    function GetTIENDAValue: String; virtual;
    procedure SetTIENDAValue(const aValue: String); virtual;
    function GetTIENDAIsNull: Boolean; virtual;
    procedure SetTIENDAIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property ID_PROVEEDOR: Integer read GetID_PROVEEDORValue write SetID_PROVEEDORValue;
    property ID_PROVEEDORIsNull: Boolean read GetID_PROVEEDORIsNull write SetID_PROVEEDORIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property FECHA_ALBARAN: DateTime read GetFECHA_ALBARANValue write SetFECHA_ALBARANValue;
    property FECHA_ALBARANIsNull: Boolean read GetFECHA_ALBARANIsNull write SetFECHA_ALBARANIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_ALMACEN: Integer read GetID_ALMACENValue write SetID_ALMACENValue;
    property ID_ALMACENIsNull: Boolean read GetID_ALMACENIsNull write SetID_ALMACENIsNull;
    property NOMBRE_ALMACEN: String read GetNOMBRE_ALMACENValue write SetNOMBRE_ALMACENValue;
    property NOMBRE_ALMACENIsNull: Boolean read GetNOMBRE_ALMACENIsNull write SetNOMBRE_ALMACENIsNull;
    property ID_PEDIDO: Integer read GetID_PEDIDOValue write SetID_PEDIDOValue;
    property ID_PEDIDOIsNull: Boolean read GetID_PEDIDOIsNull write SetID_PEDIDOIsNull;
    property REF_PED_PROVEEDOR: String read GetREF_PED_PROVEEDORValue write SetREF_PED_PROVEEDORValue;
    property REF_PED_PROVEEDORIsNull: Boolean read GetREF_PED_PROVEEDORIsNull write SetREF_PED_PROVEEDORIsNull;
    property ID_FACTURA: Integer read GetID_FACTURAValue write SetID_FACTURAValue;
    property ID_FACTURAIsNull: Boolean read GetID_FACTURAIsNull write SetID_FACTURAIsNull;
    property REF_FACTURA: String read GetREF_FACTURAValue write SetREF_FACTURAValue;
    property REF_FACTURAIsNull: Boolean read GetREF_FACTURAIsNull write SetREF_FACTURAIsNull;
    property REF_FACTURA_PROV: String read GetREF_FACTURA_PROVValue write SetREF_FACTURA_PROVValue;
    property REF_FACTURA_PROVIsNull: Boolean read GetREF_FACTURA_PROVIsNull write SetREF_FACTURA_PROVIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property PERSONA_CONTACTO: String read GetPERSONA_CONTACTOValue write SetPERSONA_CONTACTOValue;
    property PERSONA_CONTACTOIsNull: Boolean read GetPERSONA_CONTACTOIsNull write SetPERSONA_CONTACTOIsNull;
    property TELEFONO: String read GetTELEFONOValue write SetTELEFONOValue;
    property TELEFONOIsNull: Boolean read GetTELEFONOIsNull write SetTELEFONOIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property INCIDENCIAS: IROStrings read GetINCIDENCIASValue;
    property INCIDENCIASIsNull: Boolean read GetINCIDENCIASIsNull write SetINCIDENCIASIsNull;
    property INCIDENCIAS_ACTIVAS: Integer read GetINCIDENCIAS_ACTIVASValue write SetINCIDENCIAS_ACTIVASValue;
    property INCIDENCIAS_ACTIVASIsNull: Boolean read GetINCIDENCIAS_ACTIVASIsNull write SetINCIDENCIAS_ACTIVASIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property ID_TIENDA: Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull: Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property TIENDA: String read GetTIENDAValue write SetTIENDAValue;
    property TIENDAIsNull: Boolean read GetTIENDAIsNull write SetTIENDAIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IAlbaranesProveedor_Detalles }
  IAlbaranesProveedor_Detalles = interface(IDAStronglyTypedDataTable)
  ['{4589DE0C-CDAD-4373-B7D2-D433C4DED5BF}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_ALBARANValue: Integer;
    procedure SetID_ALBARANValue(const aValue: Integer);
    function GetID_ALBARANIsNull: Boolean;
    procedure SetID_ALBARANIsNull(const aValue: Boolean);
    function GetPOSICIONValue: Integer;
    procedure SetPOSICIONValue(const aValue: Integer);
    function GetPOSICIONIsNull: Boolean;
    procedure SetPOSICIONIsNull(const aValue: Boolean);
    function GetTIPO_DETALLEValue: String;
    procedure SetTIPO_DETALLEValue(const aValue: String);
    function GetTIPO_DETALLEIsNull: Boolean;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean);
    function GetCONCEPTOValue: String;
    procedure SetCONCEPTOValue(const aValue: String);
    function GetCONCEPTOIsNull: Boolean;
    procedure SetCONCEPTOIsNull(const aValue: Boolean);
    function GetCANTIDADValue: Currency;
    procedure SetCANTIDADValue(const aValue: Currency);
    function GetCANTIDADIsNull: Boolean;
    procedure SetCANTIDADIsNull(const aValue: Boolean);
    function GetIMPORTE_UNIDADValue: Currency;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency);
    function GetIMPORTE_UNIDADIsNull: Boolean;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetVISIBLEValue: Integer;
    procedure SetVISIBLEValue(const aValue: Integer);
    function GetVISIBLEIsNull: Boolean;
    procedure SetVISIBLEIsNull(const aValue: Boolean);
    function GetID_ARTICULOValue: Integer;
    procedure SetID_ARTICULOValue(const aValue: Integer);
    function GetID_ARTICULOIsNull: Boolean;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetREFERENCIA_PROVEEDORValue: String;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String);
    function GetREFERENCIA_PROVEEDORIsNull: Boolean;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_ALBARAN: Integer read GetID_ALBARANValue write SetID_ALBARANValue;
    property ID_ALBARANIsNull: Boolean read GetID_ALBARANIsNull write SetID_ALBARANIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Currency read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;
  end;

  { TAlbaranesProveedor_DetallesDataTableRules }
  TAlbaranesProveedor_DetallesDataTableRules = class(TIntfObjectDADataTableRules, IAlbaranesProveedor_Detalles)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_ALBARANValue: Integer; virtual;
    procedure SetID_ALBARANValue(const aValue: Integer); virtual;
    function GetID_ALBARANIsNull: Boolean; virtual;
    procedure SetID_ALBARANIsNull(const aValue: Boolean); virtual;
    function GetPOSICIONValue: Integer; virtual;
    procedure SetPOSICIONValue(const aValue: Integer); virtual;
    function GetPOSICIONIsNull: Boolean; virtual;
    procedure SetPOSICIONIsNull(const aValue: Boolean); virtual;
    function GetTIPO_DETALLEValue: String; virtual;
    procedure SetTIPO_DETALLEValue(const aValue: String); virtual;
    function GetTIPO_DETALLEIsNull: Boolean; virtual;
    procedure SetTIPO_DETALLEIsNull(const aValue: Boolean); virtual;
    function GetCONCEPTOValue: String; virtual;
    procedure SetCONCEPTOValue(const aValue: String); virtual;
    function GetCONCEPTOIsNull: Boolean; virtual;
    procedure SetCONCEPTOIsNull(const aValue: Boolean); virtual;
    function GetCANTIDADValue: Currency; virtual;
    procedure SetCANTIDADValue(const aValue: Currency); virtual;
    function GetCANTIDADIsNull: Boolean; virtual;
    procedure SetCANTIDADIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_UNIDADValue: Currency; virtual;
    procedure SetIMPORTE_UNIDADValue(const aValue: Currency); virtual;
    function GetIMPORTE_UNIDADIsNull: Boolean; virtual;
    procedure SetIMPORTE_UNIDADIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetVISIBLEValue: Integer; virtual;
    procedure SetVISIBLEValue(const aValue: Integer); virtual;
    function GetVISIBLEIsNull: Boolean; virtual;
    procedure SetVISIBLEIsNull(const aValue: Boolean); virtual;
    function GetID_ARTICULOValue: Integer; virtual;
    procedure SetID_ARTICULOValue(const aValue: Integer); virtual;
    function GetID_ARTICULOIsNull: Boolean; virtual;
    procedure SetID_ARTICULOIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_PROVEEDORValue: String; virtual;
    procedure SetREFERENCIA_PROVEEDORValue(const aValue: String); virtual;
    function GetREFERENCIA_PROVEEDORIsNull: Boolean; virtual;
    procedure SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_ALBARAN: Integer read GetID_ALBARANValue write SetID_ALBARANValue;
    property ID_ALBARANIsNull: Boolean read GetID_ALBARANIsNull write SetID_ALBARANIsNull;
    property POSICION: Integer read GetPOSICIONValue write SetPOSICIONValue;
    property POSICIONIsNull: Boolean read GetPOSICIONIsNull write SetPOSICIONIsNull;
    property TIPO_DETALLE: String read GetTIPO_DETALLEValue write SetTIPO_DETALLEValue;
    property TIPO_DETALLEIsNull: Boolean read GetTIPO_DETALLEIsNull write SetTIPO_DETALLEIsNull;
    property CONCEPTO: String read GetCONCEPTOValue write SetCONCEPTOValue;
    property CONCEPTOIsNull: Boolean read GetCONCEPTOIsNull write SetCONCEPTOIsNull;
    property CANTIDAD: Currency read GetCANTIDADValue write SetCANTIDADValue;
    property CANTIDADIsNull: Boolean read GetCANTIDADIsNull write SetCANTIDADIsNull;
    property IMPORTE_UNIDAD: Currency read GetIMPORTE_UNIDADValue write SetIMPORTE_UNIDADValue;
    property IMPORTE_UNIDADIsNull: Boolean read GetIMPORTE_UNIDADIsNull write SetIMPORTE_UNIDADIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property VISIBLE: Integer read GetVISIBLEValue write SetVISIBLEValue;
    property VISIBLEIsNull: Boolean read GetVISIBLEIsNull write SetVISIBLEIsNull;
    property ID_ARTICULO: Integer read GetID_ARTICULOValue write SetID_ARTICULOValue;
    property ID_ARTICULOIsNull: Boolean read GetID_ARTICULOIsNull write SetID_ARTICULOIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property REFERENCIA_PROVEEDOR: String read GetREFERENCIA_PROVEEDORValue write SetREFERENCIA_PROVEEDORValue;
    property REFERENCIA_PROVEEDORIsNull: Boolean read GetREFERENCIA_PROVEEDORIsNull write SetREFERENCIA_PROVEEDORIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TAlbaranesProveedorDataTableRules }
constructor TAlbaranesProveedorDataTableRules.Create(aDataTable: TDADataTable);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := OBSERVACIONES_OnChange;
  f_OBSERVACIONES := NewROStrings(StrList,True);

  StrList := TStringList.Create;
  StrList.OnChange := INCIDENCIAS_OnChange;
  f_INCIDENCIAS := NewROStrings(StrList,True);
end;

destructor TAlbaranesProveedorDataTableRules.Destroy;
begin
  inherited;
end;

procedure TAlbaranesProveedorDataTableRules.OBSERVACIONES_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_AlbaranesProveedorOBSERVACIONES].AsVariant := TStringList(Sender).Text;
end;

procedure TAlbaranesProveedorDataTableRules.INCIDENCIAS_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS].AsVariant := TStringList(Sender).Text;
end;

function TAlbaranesProveedorDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_EMPRESA].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_EMPRESA].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_EMPRESA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_EMPRESA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_PROVEEDORValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_PROVEEDOR].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_PROVEEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_PROVEEDOR].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_PROVEEDOR].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_PROVEEDOR].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorNOMBRE].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorNOMBRE].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorNOMBRE].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorNOMBRE].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetFECHA_ALBARANValue: DateTime;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorFECHA_ALBARAN].AsDateTime;
end;

procedure TAlbaranesProveedorDataTableRules.SetFECHA_ALBARANValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_AlbaranesProveedorFECHA_ALBARAN].AsDateTime := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetFECHA_ALBARANIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorFECHA_ALBARAN].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetFECHA_ALBARANIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorFECHA_ALBARAN].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREFERENCIA].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorREFERENCIA].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREFERENCIA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorREFERENCIA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREFERENCIA_PROVEEDOR].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorREFERENCIA_PROVEEDOR].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorTIPO].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorTIPO].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetTIPOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorTIPO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorTIPO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_ALMACENValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_ALMACEN].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_ALMACENValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_ALMACEN].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_ALMACEN].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_ALMACEN].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetNOMBRE_ALMACENValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorNOMBRE_ALMACEN].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetNOMBRE_ALMACENValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorNOMBRE_ALMACEN].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetNOMBRE_ALMACENIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorNOMBRE_ALMACEN].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetNOMBRE_ALMACENIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorNOMBRE_ALMACEN].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_PEDIDOValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_PEDIDO].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_PEDIDOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_PEDIDO].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_PEDIDOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_PEDIDO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_PEDIDOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_PEDIDO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetREF_PED_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREF_PED_PROVEEDOR].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetREF_PED_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorREF_PED_PROVEEDOR].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetREF_PED_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREF_PED_PROVEEDOR].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetREF_PED_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorREF_PED_PROVEEDOR].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_FACTURAValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_FACTURA].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_FACTURAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_FACTURA].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_FACTURA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_FACTURA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetREF_FACTURAValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetREF_FACTURAValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetREF_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetREF_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetREF_FACTURA_PROVValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA_PROV].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetREF_FACTURA_PROVValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA_PROV].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetREF_FACTURA_PROVIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA_PROV].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetREF_FACTURA_PROVIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorREF_FACTURA_PROV].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorCALLE].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorCALLE].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetCALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorCALLE].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetCALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorCALLE].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorCODIGO_POSTAL].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorCODIGO_POSTAL].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetCODIGO_POSTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorCODIGO_POSTAL].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetCODIGO_POSTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorCODIGO_POSTAL].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorPOBLACION].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorPOBLACION].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetPOBLACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorPOBLACION].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetPOBLACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorPOBLACION].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorPROVINCIA].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorPROVINCIA].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetPROVINCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorPROVINCIA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetPROVINCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorPROVINCIA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetPERSONA_CONTACTOValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorPERSONA_CONTACTO].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetPERSONA_CONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorPERSONA_CONTACTO].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetPERSONA_CONTACTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorPERSONA_CONTACTO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetPERSONA_CONTACTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorPERSONA_CONTACTO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetTELEFONOValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorTELEFONO].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetTELEFONOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorTELEFONO].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetTELEFONOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorTELEFONO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetTELEFONOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorTELEFONO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_NETO].AsCurrency;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedorIMPORTE_NETO].AsCurrency := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_NETOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_NETO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_NETOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorIMPORTE_NETO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_PORTE].AsCurrency;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedorIMPORTE_PORTE].AsCurrency := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_PORTE].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorIMPORTE_PORTE].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorDESCUENTO].AsFloat;
end;

procedure TAlbaranesProveedorDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_AlbaranesProveedorDESCUENTO].AsFloat := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorDESCUENTO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorDESCUENTO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedorIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_DESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_DESCUENTO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorIMPORTE_DESCUENTO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorBASE_IMPONIBLE].AsCurrency;
end;

procedure TAlbaranesProveedorDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedorBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetBASE_IMPONIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorBASE_IMPONIBLE].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorBASE_IMPONIBLE].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_TIPO_IVA].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_TIPO_IVA].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_TIPO_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_TIPO_IVA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_TIPO_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_TIPO_IVA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIVA].AsFloat;
end;

procedure TAlbaranesProveedorDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_AlbaranesProveedorIVA].AsFloat := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIVA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorIVA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_IVA].AsCurrency;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedorIMPORTE_IVA].AsCurrency := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_IVA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorIMPORTE_IVA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_TOTAL].AsCurrency;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedorIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorIMPORTE_TOTAL].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorIMPORTE_TOTAL].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := f_OBSERVACIONES;
  result.Text := DataTable.Fields[idx_AlbaranesProveedorOBSERVACIONES].AsString;
end;

function TAlbaranesProveedorDataTableRules.GetOBSERVACIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorOBSERVACIONES].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetOBSERVACIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorOBSERVACIONES].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetINCIDENCIASValue: IROStrings;
begin
  result := f_INCIDENCIAS;
  result.Text := DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS].AsString;
end;

function TAlbaranesProveedorDataTableRules.GetINCIDENCIASIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetINCIDENCIASIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetINCIDENCIAS_ACTIVASValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS_ACTIVAS].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetINCIDENCIAS_ACTIVASValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS_ACTIVAS].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetINCIDENCIAS_ACTIVASIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS_ACTIVAS].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetINCIDENCIAS_ACTIVASIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorINCIDENCIAS_ACTIVAS].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorFECHA_ALTA].AsDateTime;
end;

procedure TAlbaranesProveedorDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_AlbaranesProveedorFECHA_ALTA].AsDateTime := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorFECHA_ALTA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorFECHA_ALTA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorFECHA_MODIFICACION].AsDateTime;
end;

procedure TAlbaranesProveedorDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_AlbaranesProveedorFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorFECHA_MODIFICACION].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorFECHA_MODIFICACION].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorUSUARIO].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorUSUARIO].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorUSUARIO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorUSUARIO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_FORMA_PAGO].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_FORMA_PAGO].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_FORMA_PAGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_FORMA_PAGO].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_FORMA_PAGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_FORMA_PAGO].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetID_TIENDAValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_TIENDA].AsInteger;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_TIENDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedorID_TIENDA].AsInteger := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetID_TIENDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorID_TIENDA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetID_TIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorID_TIENDA].AsVariant := Null;
end;

function TAlbaranesProveedorDataTableRules.GetTIENDAValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorTIENDA].AsString;
end;

procedure TAlbaranesProveedorDataTableRules.SetTIENDAValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedorTIENDA].AsString := aValue;
end;

function TAlbaranesProveedorDataTableRules.GetTIENDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedorTIENDA].IsNull;
end;

procedure TAlbaranesProveedorDataTableRules.SetTIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedorTIENDA].AsVariant := Null;
end;


{ TAlbaranesProveedor_DetallesDataTableRules }
constructor TAlbaranesProveedor_DetallesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TAlbaranesProveedor_DetallesDataTableRules.Destroy;
begin
  inherited;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesID].AsInteger;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesID].AsInteger := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesID].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesID].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetID_ALBARANValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ALBARAN].AsInteger;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetID_ALBARANValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ALBARAN].AsInteger := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetID_ALBARANIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ALBARAN].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetID_ALBARANIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ALBARAN].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetPOSICIONValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesPOSICION].AsInteger;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetPOSICIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesPOSICION].AsInteger := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetPOSICIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesPOSICION].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetPOSICIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesPOSICION].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetTIPO_DETALLEValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesTIPO_DETALLE].AsString;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetTIPO_DETALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesTIPO_DETALLE].AsString := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetTIPO_DETALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesTIPO_DETALLE].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetTIPO_DETALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesTIPO_DETALLE].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetCONCEPTOValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesCONCEPTO].AsString;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetCONCEPTOValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesCONCEPTO].AsString := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetCONCEPTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesCONCEPTO].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetCONCEPTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesCONCEPTO].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetCANTIDADValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesCANTIDAD].AsCurrency;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetCANTIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesCANTIDAD].AsCurrency := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetCANTIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesCANTIDAD].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetCANTIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesCANTIDAD].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIMPORTE_UNIDADValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_UNIDAD].AsCurrency;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIMPORTE_UNIDADValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_UNIDAD].AsCurrency := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIMPORTE_UNIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_UNIDAD].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIMPORTE_UNIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_UNIDAD].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_TOTAL].AsCurrency;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_TOTAL].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_TOTAL].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetVISIBLEValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesVISIBLE].AsInteger;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetVISIBLEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesVISIBLE].AsInteger := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetVISIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesVISIBLE].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetVISIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesVISIBLE].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetID_ARTICULOValue: Integer;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ARTICULO].AsInteger;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetID_ARTICULOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ARTICULO].AsInteger := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetID_ARTICULOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ARTICULO].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetID_ARTICULOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesID_ARTICULO].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesDESCUENTO].AsFloat;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesDESCUENTO].AsFloat := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesDESCUENTO].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesDESCUENTO].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_PORTE].AsCurrency;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_PORTE].AsCurrency := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_PORTE].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesIMPORTE_PORTE].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA].AsString;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA].AsString := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA].AsVariant := Null;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetREFERENCIA_PROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA_PROVEEDOR].AsString;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetREFERENCIA_PROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA_PROVEEDOR].AsString := aValue;
end;

function TAlbaranesProveedor_DetallesDataTableRules.GetREFERENCIA_PROVEEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA_PROVEEDOR].IsNull;
end;

procedure TAlbaranesProveedor_DetallesDataTableRules.SetREFERENCIA_PROVEEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_AlbaranesProveedor_DetallesREFERENCIA_PROVEEDOR].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_AlbaranesProveedor, TAlbaranesProveedorDataTableRules);
  RegisterDataTableRules(RID_AlbaranesProveedor_Detalles, TAlbaranesProveedor_DetallesDataTableRules);

end.
